=== debian/tests/control ===
Test-Command: /bin/sh debian/tests/upstream-binaries librocsolver0-tests
Depends: librocsolver0-tests, libopenblas0-pthread
Restrictions: skippable, allow-stderr, needs-sudo
Architecture: amd64
